<template>
  <div class="freeze">
    <meta name="viewport" content="width=device-width,initial scale=" />
    <link rel="stylesheet" href="https://www.w3schools.com/lib/w3.css" />
    <div class="container2">
      <div class="pro-items-one">
        <div class="items-price-list-one">
          <p class="pro-s-no-t-one">S.No</p>
          <p class="pro-img-t-one">Image</p>
          <p class="pro-name-t-one">Product Name</p>
          <p class="pro-price-t-one">Price</p>
          <p class="pro-quantity-t-one">Quantity</p>
          <p class="pro-total-t-one">Total</p>
        </div>
      </div>
      <div class="sele-content" v-for="(db, i) in selectedArray" :key="i">
        <p class="sele-s-no">{{ i + 1 }}</p>
        <img class="sele-pro-image" :src="db.Image" alt="" />
        <p class="sele-pro-name">{{ db.ProductName }}</p>
        <p class="sele-pro-price">{{ db.Price }}</p>
        <!-- <p class="sele-pro-qty">{{ db.Quanity }}</p> -->
        <!-- <v-text-field
          v-model="db.Quanity"
          type="number"
          label="Regular"
          width="10%"
        ></v-text-field> -->
        <!-- <v-col md="3"> -->
        <!-- <input
            v-model="db.Quanity"
            type="number"
            outlined
            @input="updatedOne(db.Quanity, db.ProductName)"
            class="qtyBox"
            
            dense
          ></input> -->
        <!-- class="qtyBox" -->
        <input
          v-model="db.Quanity"
          type="number"
          outlined
          @input="updatedOne(db.Quanity, db.ProductName)"
          class="sele-pro-qty"
          dense
        />
        <!-- </v-col> -->

        <p class="sele-pro-totol">{{ db.TotalPrice }}</p>
      </div>
      <div>
        <p class="GrandTotal">Grandtotal = ₹{{ totalPrice() }}</p>
      </div>
      <div class="user-form">
        <template>
          <v-app class="form-app">
            <p class="Shipping">Shipping Address</p>
            <v-form ref="Details" v-model="valid" lazy-validation>
              <div class="form-flex">
                <v-text-field
                  v-model="userName"
                  :counter="20"
                  :rules="NameRules"
                  label="Name"
                  required
                  class="pl-3 pr-4"
                ></v-text-field>
                <v-text-field
                  v-model="userMobile"
                  :rules="phonenumberRules"
                  :maxlength="10"
                  label="Phone Number"
                  required
                  class="pl-3 pr-4"
                ></v-text-field>
              </div>

              <div class="form-flex">
                <v-text-field
                  v-model="userEmail"
                  label="E-mail (Optional)"
                  required
                  class="pl-3 pr-4"
                ></v-text-field>
                <v-text-field
                  v-model="userzipCode"
                  :rules="zipRules"
                  :maxlength="6"
                  label="ZipCode"
                  required
                  class="pl-3 pr-4"
                ></v-text-field>
              </div>

              <v-textarea
                filled
                auto-grow
                label="Address"
                :rules="AddressRules"
                rows="2"
                row-height="20"
                v-model="userAddress"
              ></v-textarea>
              <div class="form-btn">
                <v-btn
                  :disabled="!valid"
                  color="green"
                  class="mr-4"
                  @click="onproceedtocheckout"
                >
                  Proceed to checkOut
                </v-btn>
                <v-btn color="red" @click="continueshopping">
                  Continue Shopping
                </v-btn>
              </div>
            </v-form>
          </v-app>
        </template>
      </div>
    </div>
  </div>
</template>
<script>
export default {
  data() {
    return {
      AddressRules: [(v) => !!v || " Address is required"],
      NameRules: [
        (v) => !!v || "Name is required",
        (v) =>
          !/[^a-zA-Z ]/.test(v) ||
          " Name should not contain special characters & Numbers",
        // v => !/[^0-9 ]/.test(v) || 'First Name should not contain special characters & Numbers'
      ],

      zipRules: [
        (v) => !!v || "Zip Code is required",
        (v) => !/[^0-9]/.test(v) || "Zip Code must contain Only Numbers",
      ],
      phonenumberRules: [
        (v) => !!v || "phone number is required",
        (v) => !/[^0-9]/.test(v) || "phone number must contain Only Numbers",
        (v) =>
          (!!v && v.length >= 10) ||
          "phone number must be atleast 10 Characters",
      ],
      valid: false,
      userName: "",
      userMobile: "",
      userEmail: "",
      userzipCode: "",
      userAddress: "",
      totalvalue: null,
    };
  },
  props: ["selectedArray"],
  methods: {
    continueshopping() {
      // debugger; // eslint-disable-line no-debugger
      this.$emit("continueshop", this.selectedArray.ProductName);
      this.$store.state.userName = this.userName;
      this.$store.state.userMobile = this.userMobile;
      this.$store.state.userEmail = this.userEmail;
      this.$store.state.userzipCode = this.userzipCode;
      this.$store.state.userAddress = this.userAddress;
    },
    onproceedtocheckout() {
      // debugger; // eslint-disable-line no-debugger
      if (this.$refs.Details.validate()) {
        this.$emit(
          "proceedtocheckout",
          this.userName,
          this.userMobile,
          this.userEmail,
          this.userzipCode,
          this.userAddress
        );
      }
    },
    totalPrice() {
      var sum = 0;
      var id = this.selectedArray;
      for (var is = 0; is < id.length; is++) {
        if (isFinite(id[is].TotalPrice)) {
          sum += +id[is].TotalPrice;
        }
      }
      return (this.totalvalue = sum);
    },
    updatedOne(updateQty, upName) {
      this.$emit("qtyUp", updateQty, upName);
      console.log(updateQty, upName);
    },
  },
  mounted() {
    // debugger; // eslint-disable-line no-debugger
    // setTimeout(() => {
    if (this.$store.state.userName) {
      this.userName = this.$store.state.userName;
      this.userMobile = this.$store.state.userMobile;
      this.userEmail = this.$store.state.userEmail;
      this.userzipCode = this.$store.state.userzipCode;
      this.userAddress = this.$store.state.userAddress;
    }
    // }, 500);
  },
};
</script>

<style scoped>
.GrandTotal {
  display: flex;
  align-items: center;
  justify-content: center;
  color: black;
  margin: auto;
  text-align: center;
  width: 75%;
  padding: 5px 50px 5px 50px;
  background-color: #fff;
  font-family: sans-serif;
  font-weight: 700;
  font-size: 30px;
}
.GrandTotal:hover {
  background-color: #edecff;
}
.pro-items-one {
  /* background-color: #C4D3F5; */
  margin: auto;
  width: 75%;
  background-color: #6c79e0;
  display: flex;
  padding: 15px 50px 0px 50px;
  color: #fff;
}
.items-price-list-one {
  display: flex;
  width: 930px;
  margin: auto;
}
/* .flex-container {
  padding: 0;
  margin: auto;
  width: 80%;
  padding: 2rem;
  list-style: none;
  display: flex;
}
.space-between {
  justify-content: space-between;
} */
.pro-s-no-t-one {
  color: white;
  width: 50px;
  text-align: center;
}
.pro-img-t-one {
  color: white;
  width: 200px;
  text-align: center;
}
.pro-name-t-one {
  color: white;
  width: 200px;
  text-align: center;
}
.freeze {
  overflow: scroll;
  position: fixed;
  width: 100%;
  height: 100%;
  top: 0;
  left: 0;
  right: 0;
  bottom: 0;
  background-color: rgba(255, 255, 255, 1);
  z-index: 1000000;
  cursor: pointer;
}
.pro-price-t-one {
  color: white;
  width: 150px;
  text-align: center;
}
.pro-quantity-t-one {
  color: white;
  width: 150px;
  text-align: center;
}
.pro-total-t-one {
  color: white;
  width: 160px;
  text-align: center;
}
.sele-content {
  display: flex;
  align-items: center;
  justify-content: center;
  color: black;
  margin: auto;
  text-align: center;
  width: 75%;
  padding: 5px 50px 5px 50px;
  background-color: #fff;
}
.sele-content:hover {
  background-color: #edecff;
}
.sele-s-no {
  width: 50px;
  text-align: center;
}
.sele-pro-name {
  width: 200px;
  text-align: center;
}
.sele-pro-image {
  width: 200px;
  height: 150px;
  text-align: center;
}
.sele-pro-price {
  width: 180px;
  text-align: center;
}
.sele-pro-qty {
  width: 150px;
  text-align: center;
  border-radius: 5px;
  border: 1px solid #555;
}
/* .v-text-field {
  width: 150px;
  text-align: center;
} */
/* .qtyBox {
  width: 110px !important;
  text-align: center;
  margin: auto;
  border-radius: 5px;
  border: 1px solid #555555;
} */
.sele-pro-totol {
  width: 160px;
  text-align: center;
}
.user-form {
  width: 75%;
  margin: auto;
}
.form-flex {
  display: flex;
}
.form-btn {
  width: 450px;
  margin: auto;
}
.form-app {
  height: 350px;
  border-radius: 8px;
  border: solid 2px #6c79e0;
  margin-top: 10px;
}
.Shipping {
  text-align: center;
  font-size: 30px;
  font-weight: 400;
  border-bottom: solid 2px #6c79e0;
  width: 250px;
  margin: 0px auto;
}
</style>
